Sicily1099-Packing Passengers-拓展欧几里德算法

2024-01-14 18:10

本文主要是介绍Sicily1099-Packing Passengers-拓展欧几里德算法,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

最终代码地址:https://github.com/laiy/Datastructure-Algorithm/blob/master/sicily/1099.c

做这题的时候查了别人的做法花了半天都没搞明白怎么做的,我认为别的博客写的难以让人理解所以就造了这个轮子。

题目:

1099. Packing Passengers

Constraints

Time Limit: 1 secs, Memory Limit: 32 MB

Description

 

PTA, Pack ‘em Tight Airlines is attempting the seemingly impossible—to fly with only full planes and still make a profit. Their strategy is simplicity and efficiency. Their fleet consists of 2 types of equipment (airline lingo for airplanes). Type A aircraft cost costA dollars to operate per flight and can carry passengersA passengers. Type B aircraft cost costB dollars to operate per flight and can carry passengersB passengers.

PTA has been using software that works well for fewer than 100 passengers, but will be far too slow for the number of passengers they expect to have with larger aircraft. PTA wants you to write a program that fills each aircraft to capacity (in keeping with the name Pack 'em Tight) and also minimizes the total cost of operations for that route.

 

Input

 

The input file may contain data sets. Each data set begins with a line containing the integer n (1 <= n <= 2,000,000,000) which represents the number of passengers for that route. The second line contains costA and passengersA, and the third line contains costB and passengersB. There will be white space between the pairs of values on each line. Here, costA, passengersA, costB, and passengersB are all nonnegative integers having values less than 2,000,000,001.
After the end of the final data set, there is a line containing “0” (one zero) which should not be processed.

 

Output

 

For each data set in the input file, the output file should contain a single line formatted as follows:
Data set <N>: <A> aircraft A, <B> aircraft B
Where <N> is an integer number equal to 1 for the first data set, and incremented by one for each subsequent data set, <A> is the number of airplanes of type A in the optimal solution for the test case, and <B> is the number of airplanes of type B in the optimal solution. The 'optimal' solution is a solution that lets PTA carry the number of passengers specified in the input for that data set using only airplanes loaded to their full capacity and that minimizes the cost of operating the required flights. If multiple alternatives exist fitting this description, select the one that uses most airplanes of type A. If no solution exists for PTA to fly the given number of passengers, the out line should be formatted as follows:
Data set <N>: cannot be flown

 

Sample Input

600
30 20
20 40
550
1 13
2 29
549
1 13
2 29
2000000000
1 2
3 7
599
11 20
22 40
0

Sample Output

Data set 1: 0 aircraft A, 15 aircraft B
Data set 2: 20 aircraft A, 10 aircraft B
Data set 3: 11 aircraft A, 14 aircraft B
Data set 4: 6 aircraft A, 285714284 aircraft B
Data set 5: cannot be flown

题意就是求出passenger_A * x + passenger_B * y = passengers, 使得cost_A * x + cost_B * y最小。

我起初的想法是算出A和B哪个性价比大,然后取性价比大的那个最大的可能,再逐步递减到能够整除为止,这样做的效率是0.05s。

代码如下:

 1 // Problem#: 1099
 2 // Submission#: 4376506
 3 // The source code is licensed under Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License
 4 // URI: http://creativecommons.org/licenses/by-nc-sa/3.0/
 5 // All Copyright reserved by Informatic Lab of Sun Yat-sen University
 6 #include <cstdio>
 7 
 8 inline int fix_upper(int upper, int passengers, int passenger_upper, int passenger_others) {
 9     int temp = passengers - upper * passenger_upper;
10     while (temp % passenger_others) {
11         if (upper == 0)
12             return -1;
13         upper--, temp += passenger_upper;
14     }
15     return upper;
16 }
17 
18 int main() {
19     int passengers;
20     int cost_A, passenger_A, cost_B, passenger_B;
21     int upper, others;
22     int count = 1;
23     while (scanf("%d", &passengers) && passengers) {
24         scanf("%d %d", &cost_A, &passenger_A);
25         scanf("%d %d", &cost_B, &passenger_B);
26         if (passenger_A == 0 && passenger_B == 0) {
27             printf("Data set %d: cannot be flown\n", count++);
28             continue;
29         }
30         if ((passenger_A == 0 && passenger_B != 0) || (cost_A == 0 && cost_B == 0 && passenger_B > passenger_A)) {
31             if (passengers % passenger_B)
32                 printf("Data set %d: cannot be flown\n", count++);
33             else
34                 printf("Data set %d: %d aircraft A, %d aircraft B\n", count++, 0, passengers / passenger_B);
35             continue;
36         }
37         if ((passenger_B == 0 && passenger_A != 0) || (cost_A == 0 && cost_B == 0 && passenger_A > passenger_B)) {
38             if (passengers % passenger_A)
39                 printf("Data set %d: cannot be flown\n", count++);
40             else
41                 printf("Data set %d: %d aircraft A, %d aircraft B\n", count++, passengers / passenger_A, 0);
42             continue;
43         }
44         if (double(cost_A) / double(passenger_A) <= double(cost_B) / double(passenger_B)) {
45             upper = passengers / passenger_A;
46             upper = fix_upper(upper, passengers, passenger_A, passenger_B);
47             others = (passengers - upper * passenger_A) / passenger_B;
48             if (upper != -1)
49                 printf("Data set %d: %d aircraft A, %d aircraft B\n", count++, upper, others);
50             else
51                 printf("Data set %d: cannot be flown\n", count++);
52         } else {
53             upper = passengers / passenger_B;
54             upper = fix_upper(upper, passengers, passenger_B, passenger_A);
55             others = (passengers - upper * passenger_B) / passenger_A;
56             if (upper != -1)
57                 printf("Data set %d: %d aircraft A, %d aircraft B\n", count++, others, upper);
58             else
59                 printf("Data set %d: cannot be flown\n", count++);
60         }
61     }
62     return 0;
63 }                                 

写的很丑请见谅,我只是为了AC,我知道这样做并不好当时。

然后就来讲一下更好的做法:

我们要求的是x, y满足passenger_A * x + passenger_B * y = passengers。

拓展欧几里德算法其实就是在欧几里德算法求解过程中把x和y算出来了,具体是这样的:a * x + b * y = gcd(a, b)。

其实就是把上面等式的x和y求出来了,原理如下:

我们知道欧几里德算法原理是gcd(a, b) = gcd(b, a % b)不断递归下去,拓展欧几里德算法其实也是这个递归,只不过多加了一些x和y的赋值罢了。

假设在某一次递归过程中,a' = b, b' = a % b = a - a / b * b(C语言整数算法)。

那么gcd(a, b) = gcd(a', b') = a'x + b'y。

消去a', b'得到:ay +b(x - a  /  b * y) = Gcd(a, b)。

可以看到,这里的系数a的系数为y,b的系数为x - a / b * y。

通过这个原理递归我们最终得到的x和y就满足a * x + b * y = gcd(a, b)。

好,但是从这个算法也看不到和我们题目的关系是不是?

来看,首先有:passenger_A * x + passenger_B * y = gcd(passenger_A, passenger_B)

我们把上面的式子同时乘于passengers / gcd(passenger_A, passenger_B)试试:

passenger_A * (x * passengers / gcd(passenger_A, passenger_B)) + passenger_B * (y * passengers / gcd(passenger_A, passenger_B)) = passengers。

这个式子是不是就和passenger_A * x + passenger_B * y = passengers吻合了?

对应的x为(x * passengers / gcd(passenger_A, passenger_B)), y为(y * passengers / gcd(passenger_A, passenger_B))。

所以:我们先用欧几里德算法求出passenger_A * x + passenger_B * y = gcd(passenger_A, passenger_B)的x, y。

然后在通过变换得到passenger_A * x + passenger_B * y = passenger的x, y。

现在设这里求得的x, y为x0, y0。

这样就得到了满足以上等式一组的x0和y0的解了。

然后来看线型同余方程:

数论中,线性同余方程是最基本的同余方程,“线性”表示方程的未知数次数是一次,即形如:

ax \equiv b \ \pmod{n} \ \ \ \ (1)

的方程。此方程有解当且仅当 b 能够被 a 与 n 的最大公约数整除(记作 gcd(a,n) | b)。这时,如果 x0 是方程的一个解,那么所有的解可以表示为:

\{x_0+k\frac{n}{d}\mid k\in\Bbb{Z}\}.

其中 d 是a 与 n 的最大公约数。在模 n 的完全剩余系 {0,1,…,n-1} 中,恰有 d 个解。

所以,如果passengers不能整除gcd(passenger_A, passenger_B)则式子是无解的,若有解:

x = x0 + (passenger_B / gcd(passenger_A, passenger_B)) * k, y = y0 - (passenger_A / gcd(passenger_A, passenger_B)) * k, k为任意整数。

然后,根据题意,x >= 0, y >= 0。

所以有:

x0 + (passenger_B / gcd(passenger_A, passenger_B)) * k >= 0

=>

k >= (-x0) / (passenger_B / gcd(passenger_A, passenger_B))

y0 - (passenger_A / gcd(passenger_A, passenger_B)) * k >= 0

=>

k <= (y0) / (passenger_A / gcd(passenger_A, passenger_B))。

所以k的范围为:[(-x0) / (passenger_B / gcd(passenger_A, passenger_B)), (y0) / (passenger_A / gcd(passenger_A, passenger_B))]

然后来看:

我们的目标是cost_A * x + cost_B * y最小,带入x和y的表达式得:

cost_A * (x0 + (passenger_B / gcd(passenger_A, passenger_B)) * k) + cost_B * (y0 - (passenger_A / gcd(passenger_A, passenger_B)) * k)

消去x0, y0, gcd无关因素影响, 有:

cost_A * passenger_B * k - cost_B * passenger_A * k = k * (cost_A * passenger_B - cost_B * passenger_A)

好,那么就很简单了,如果 (cost_A * passenger_B - cost_B * passenger_A)为负,则k取最大值即可。

如果为正,k取最小值即可。然后得到k的值带入求出对应x和y即可。

代码如下:

 1 #include <cstdio>
 2 #include <cmath>
 3 
 4 inline long long gcd_extend(int &a, int b, long long *x, long long *y) {
 5     static long long r, t;
 6     if (b == 0) {
 7         *x = 1, *y = 0;
 8         return a;
 9     } else {
10         r = gcd_extend(b, a % b, x, y);
11         t = *x;
12         *x = *y;
13         *y = t - a / b * *y;
14         return r;
15     }
16 }
17 
18 int main() {
19     int passengers;
20     int cost_A, passenger_A, cost_B, passenger_B;
21     int count = 1;
22     long long lower, upper, k, gcd, x, y;
23     while (scanf("%d", &passengers) && passengers) {
24         scanf("%d %d", &cost_A, &passenger_A);
25         scanf("%d %d", &cost_B, &passenger_B);
26         gcd = gcd_extend(passenger_A, passenger_B, &x, &y);
27         if (passengers % gcd == 0) {
28             x *= passengers / gcd;
29             y *= passengers / gcd;
30             upper = floor((double)y / (passenger_A / gcd));
31             lower = ceil((double)-x / (passenger_B / gcd));
32             k = passenger_B * cost_A - passenger_A * cost_B <= 0 ? upper : lower;
33             printf("Data set %d: %lld aircraft A, %lld aircraft B\n", count++, x + (passenger_B / gcd) * k, y - (passenger_A / gcd) * k);
34         } else
35             printf("Data set %d: cannot be flown\n", count++);
36     }
37     return 0;
38 }

 这种做法效率为0.02s。

转载于:https://www.cnblogs.com/laiy/p/sicily_1099.html

这篇关于Sicily1099-Packing Passengers-拓展欧几里德算法的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/606051

相关文章

不懂推荐算法也能设计推荐系统

本文以商业化应用推荐为例,告诉我们不懂推荐算法的产品,也能从产品侧出发, 设计出一款不错的推荐系统。 相信很多新手产品,看到算法二字,多是懵圈的。 什么排序算法、最短路径等都是相对传统的算法(注:传统是指科班出身的产品都会接触过)。但对于推荐算法,多数产品对着网上搜到的资源,都会无从下手。特别当某些推荐算法 和 “AI”扯上关系后,更是加大了理解的难度。 但,不了解推荐算法,就无法做推荐系

康拓展开(hash算法中会用到)

康拓展开是一个全排列到一个自然数的双射(也就是某个全排列与某个自然数一一对应) 公式: X=a[n]*(n-1)!+a[n-1]*(n-2)!+...+a[i]*(i-1)!+...+a[1]*0! 其中,a[i]为整数,并且0<=a[i]<i,1<=i<=n。(a[i]在不同应用中的含义不同); 典型应用: 计算当前排列在所有由小到大全排列中的顺序,也就是说求当前排列是第

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

综合安防管理平台LntonAIServer视频监控汇聚抖动检测算法优势

LntonAIServer视频质量诊断功能中的抖动检测是一个专门针对视频稳定性进行分析的功能。抖动通常是指视频帧之间的不必要运动,这种运动可能是由于摄像机的移动、传输中的错误或编解码问题导致的。抖动检测对于确保视频内容的平滑性和观看体验至关重要。 优势 1. 提高图像质量 - 清晰度提升:减少抖动,提高图像的清晰度和细节表现力,使得监控画面更加真实可信。 - 细节增强:在低光条件下,抖

【数据结构】——原来排序算法搞懂这些就行,轻松拿捏

前言:快速排序的实现最重要的是找基准值,下面让我们来了解如何实现找基准值 基准值的注释:在快排的过程中,每一次我们要取一个元素作为枢纽值,以这个数字来将序列划分为两部分。 在此我们采用三数取中法,也就是取左端、中间、右端三个数,然后进行排序,将中间数作为枢纽值。 快速排序实现主框架: //快速排序 void QuickSort(int* arr, int left, int rig

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

秋招最新大模型算法面试,熬夜都要肝完它

💥大家在面试大模型LLM这个板块的时候,不知道面试完会不会复盘、总结,做笔记的习惯,这份大模型算法岗面试八股笔记也帮助不少人拿到过offer ✨对于面试大模型算法工程师会有一定的帮助,都附有完整答案,熬夜也要看完,祝大家一臂之力 这份《大模型算法工程师面试题》已经上传CSDN,还有完整版的大模型 AI 学习资料,朋友们如果需要可以微信扫描下方CSDN官方认证二维码免费领取【保证100%免费

dp算法练习题【8】

不同二叉搜索树 96. 不同的二叉搜索树 给你一个整数 n ,求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种?返回满足题意的二叉搜索树的种数。 示例 1: 输入:n = 3输出:5 示例 2: 输入:n = 1输出:1 class Solution {public int numTrees(int n) {int[] dp = new int

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

最大公因数:欧几里得算法

简述         求两个数字 m和n 的最大公因数,假设r是m%n的余数,只要n不等于0,就一直执行 m=n,n=r 举例 以18和12为例 m n r18 % 12 = 612 % 6 = 06 0所以最大公因数为:6 代码实现 #include<iostream>using namespace std;/